
-- thingie from demo 3
-- yayy!!! hooray!!! yippee!!!
-- not sure what funny thing i could say here :P
-- -pac

freeslot(
	"S_ASNICK_ATK"
)

sfxinfo[freeslot("sfx_snatk1")].caption = "Attacking"
sfxinfo[freeslot("sfx_snatk2")].caption = "Attacking"

states[S_ASNICK_ATK] = {
	sprite = SPR_PLAY,
	frame = SPR2_NATK|FF_ANIMATE,
	tics = (F+1)*2,
	nextstate = S_ASNICK_ATK,
	var1 = F,
	var2 = 2,
}

local function canAtk(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or p.powers[pw_carry]
	or p.asnickfireass
	or p.asnickgp.active
	or p.asnickwallrun
	or p.asnickceilbonk
	or p.altsnickdived
	or p.altsnicksj.enabled
		return false
	end
	return true
end

local function initVar()
	local t = {
		active = false,
		tics = 0,
		frame = 0
	}
	return t
end

addHook("PlayerSpawn", function(p)
	p.asnickatk = initVar()
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick"
	or not p.asnickbinds then return end
	
	if not p.asnickatk then
		p.asnickatk = initVar()
	end
	local a = p.asnickatk
	
	if not a.active
	and canAtk(p)
	and not (p.pflags & PF_STASIS)
	and not (p.pflags & PF_THOKKED)
	and (p.cmd.buttons & p.asnickbinds.attack)
	and not (p.lastbuttons & p.asnickbinds.attack) then
		S_StartSound(p.mo, sfx_snatk1)
		S_StartSound(p.mo, sfx_snatk2)
		a.active = true
		if p.asnickmach
		and p.asnickmach.num >= 2 then
			local mul = (p.mo.eflags & MFE_UNDERWATER) and 3*FU/2 or FU
			P_SetObjectMomZ(p.mo, 7*mul)
			p.pflags = $1|PF_THOKKED
		end
		if not P_IsObjectOnGround(p.mo) then
			p.pflags = $1|PF_THOKKED
		end
	end
	
	if not a.active then return end
	
	if not canAtk(p)
	or p.mo.state == S_ASNICK_ATK and p.mo.tics == 1 then
		if p.mo.state == S_ASNICK_ATK and p.mo.tics == 1 then
			if p.asnickmach.num >= 2 then
				p.mo.state = S_ASNICK_ATK
			else
				p.mo.state = S_ASNICK_JUMPFALL
			end
			p.panim = PA_FALL
			p.asnickmach.time = max($, 1)
		end
		p.asnickatk = initVar()
		return
	end
	
	p.powers[pw_strong] = $1|STR_ATTACK|STR_WALL|STR_ANIM
	
	if not (p.cmd.forwardmove or p.cmd.sidemove)
	and (p.rmomx or p.rmomy) then
		p.mo.momx = p.cmomx
		p.mo.momy = p.cmomy
		p.rmomx = 0
		p.rmomy = 0
	end
	
	if p.mo.state == S_ASNICK_ATK then
		a.frame = p.mo.frame
		a.tics = p.mo.tics
	else
		p.mo.state = S_ASNICK_ATK
		if (a.frame or a.tics) then
			p.mo.frame = a.frame
			p.mo.tics = a.tics
		end
	end
end)