
-- so it initializes your snick variables
-- and also resets stuff when you spawn
-- -Pacola

local function initializeVars(p)
	p.asnickmach = {
		num = 0,
		time = 0
	}
	p.asnicktaunting = false
	p.asnicktaunt = nil
	p.asnicktfx = nil
	p.asnickparry = false
	p.asnickparryt = nil
	p.asnickpeelout = false
	p.asnickwallrun = false
	p.asnickceilbonk = false
	p.asnickgp = {
		active = false,
		landed = false,
		momz = 0,
		o = nil
	}
	p.altsnickdived = false
	p.asnickroll = {
		active = false,
		ang = 0,
		speed = 0
	}
	p.altsnicksj = {
		enabled = false,
		sjumped = false
	}
	p.altsnicksjl = 0
	if p.asnicksjcolor == nil
		p.asnicksjcolor = "invcolor"
	end
	p.asnicksjoverlay = nil
	p.asnickfireass = false
	if p.altsnickrobot == nil
		p.altsnickrobot = false
	end
	p.asnickroboslide = false
	p.altsnickrobotpound = false
end

COM_AddCommand("doorstuck", function(p, ...)
	if not p.asnickshouldactuallyusethisthing then return end
	
	-- the BT_ numbers work fine
	-- since they're not that big anyways :P
	local keys = {...}
	if io then
		local file = io.openlocal("client/altsnick/binds.cfg", "w+")
		-- line order is based on the table order below :P
		file:seek("set") -- making sure!!
		file:write("hey, it's best you don't edit this!\n")
		for _, v in ipairs(keys) do
			file:write(v+"\n")
		end
		file:flush()
	end
	
	p.asnickbinds.up = keys[1]
	p.asnickbinds.down = keys[2]
	p.asnickbinds.taunt = keys[3]
	p.asnickbinds.mach = keys[4]
	p.asnickbinds.attack = keys[5]
	p.asnickshouldactuallyusethisthing = false
end)

local function doCommand(p)
	if not io then return end
	p.asnickshouldactuallyusethisthing = true
	
	local file = io.openlocal("client/altsnick/binds.cfg", "r")
	local keys = {
		[1] = BT_CUSTOM1,
		[2] = BT_CUSTOM2,
		[3] = BT_TOSSFLAG,
		[4] = BT_CUSTOM1,
		[5] = BT_SPIN
	}
	if file then
		local lineNum = 1
		for line in file:lines() do
			--line = $:gsub("\n", "")
			if tonumber(line) == nil then continue end
			
			keys[lineNum] = tonumber(line)
			lineNum = $+1
		end
	end
	
	local str = ""
	for _, v in ipairs(keys) do
		str = $+tostring(v)+"-"
	end
	str = $:gsub("-", " ")
	COM_BufInsertText(p, "doorstuck "+str)
end

local function initBinds(p)
	local t = {
		up = BT_CUSTOM1,
		down = BT_CUSTOM2,
		taunt = BT_TOSSFLAG,
		mach = BT_CUSTOM1,
		attack = BT_SPIN
	}
	return t
end

addHook("PlayerSpawn", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	initializeVars(p)
	if not p.asnickbinds then
		p.asnickbinds = initBinds(p)
		doCommand(p)
	end
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if p.asnickmach == nil then
		initializeVars(p)
	end
	if not p.asnickbinds then
		p.asnickbinds = initBinds(p)
		doCommand(p)
	end
end)